(function ($) {
    'use strict';

    jQuery(document).ready(function () {

        var timer;

        function getCheckoutData() { //Reading WooCommerce field values

            if (jQuery("#billing_email").length > 0) { //If email address exists

                var sl_phone = jQuery("#billing_phone").val();
                var sl_email = jQuery("#billing_email").val();

                var atposition = sl_email.indexOf("@");
                var dotposition = sl_email.lastIndexOf(".");

                if (typeof sl_phone === 'undefined' || sl_phone === null) { //If phone number field does not exist on the Checkout form
                    sl_phone = '';
                }

                clearTimeout(timer);

                if (!(atposition < 1 || dotposition < atposition + 2 || dotposition + 2 >= sl_email.length)) { //Checking if the email field is valid or phone number is longer than 1 digit
                    //If Email or Phone valid
                    var sl_name = jQuery("#billing_first_name").val();
                    var sl_surname = jQuery("#billing_last_name").val();
                    var sl_country = jQuery("#billing_country").val();
                    var sl_city = jQuery("#billing_city").val();

                    //Other fields used for "Remember user input" function
                    var sl_billing_company = jQuery("#billing_company").val();
                    var sl_billing_address_1 = jQuery("#billing_address_1").val();
                    var sl_billing_address_2 = jQuery("#billing_address_2").val();
                    var sl_billing_state = jQuery("#billing_state").val();
                    var sl_billing_postcode = jQuery("#billing_postcode").val();
                    var sl_shipping_first_name = jQuery("#shipping_first_name").val();
                    var sl_shipping_last_name = jQuery("#shipping_last_name").val();
                    var sl_shipping_company = jQuery("#shipping_company").val();
                    var sl_shipping_country = jQuery("#shipping_country").val();
                    var sl_shipping_address_1 = jQuery("#shipping_address_1").val();
                    var sl_shipping_address_2 = jQuery("#shipping_address_2").val();
                    var sl_shipping_city = jQuery("#shipping_city").val();
                    var sl_shipping_state = jQuery("#shipping_state").val();
                    var sl_shipping_postcode = jQuery("#shipping_postcode").val();
                    var sl_order_comments = jQuery("#order_comments").val();
                    var sl_create_account = jQuery("#createaccount");
                    var sl_ship_elsewhere = jQuery("#ship-to-different-address-checkbox");

                    if (sl_create_account.is(':checked')) {
                        sl_create_account = 1;
                    } else {
                        sl_create_account = 0;
                    }

                    if (sl_ship_elsewhere.is(':checked')) {
                        sl_ship_elsewhere = 1;
                    } else {
                        sl_ship_elsewhere = 0;
                    }

                    var data = {
                        action: "slsave_data",
                        sl_email: sl_email,
                        sl_name: sl_name,
                        sl_surname: sl_surname,
                        sl_phone: sl_phone,
                        sl_country: sl_country,
                        sl_city: sl_city,
                        sl_billing_company: sl_billing_company,
                        sl_billing_address_1: sl_billing_address_1,
                        sl_billing_address_2: sl_billing_address_2,
                        sl_billing_state: sl_billing_state,
                        sl_billing_postcode: sl_billing_postcode,
                        sl_shipping_first_name: sl_shipping_first_name,
                        sl_shipping_last_name: sl_shipping_last_name,
                        sl_shipping_company: sl_shipping_company,
                        sl_shipping_country: sl_shipping_country,
                        sl_shipping_address_1: sl_shipping_address_1,
                        sl_shipping_address_2: sl_shipping_address_2,
                        sl_shipping_city: sl_shipping_city,
                        sl_shipping_state: sl_shipping_state,
                        sl_shipping_postcode: sl_shipping_postcode,
                        sl_order_comments: sl_order_comments,
                        sl_create_account: sl_create_account,
                        sl_ship_elsewhere: sl_ship_elsewhere
                    }

                    timer = setTimeout(function () {
                        jQuery.post(ajaxLink.ajaxurl, data,
                            function (response) {
                                //console.log(response);
                            });

                    }, 1000);
                } else {
                    //console.log("Not a valid e-mail or phone address");
                }
            }
        }

        jQuery("#billing_email, #billing_phone, input.input-text, input.input-checkbox, textarea.input-text").on("keyup keypress change", getCheckoutData); //All action happens on or after changing Email or Phone fields or any other fields in the Checkout form. All Checkout form input fields are now triggering plugin action. Data saved to Database only after Email or Phone fields have been entered.
        jQuery(window).on("load", getCheckoutData); //Automatically collect and save input field data if input fields already filled on page load

    });

})(jQuery);