<?php

/**
 * SL_Webhook class
 *
 * Handles communication with SendLane Ecom Server
 *
 */

class SL_Webhook
{
    private $domain;
    private $handle;
    private $header;
    private $postfields = [];
    private $url;

    public $response;

    public function sl_set_abandoned_checkout_webhook($webhook, $session_id)
    {
        $this->domain = get_option('sendlane_domain');
        $this->url = isset($webhook['delivery_url']) ? $webhook['delivery_url'] : '';
        $webhookId = isset($webhook['webhook_id']) ? $webhook['webhook_id'] : '';

        $this->header = [
            'x-wc-webhook-signature: ' . $this->domain . '.' . $session_id,
            'x-wc-webhook-topic: ' . SL_WEBHOOK_TOPIC,
            'x-wc-webhook-delivery-id: ' . $this->domain . '.' . time(),
            "x-wc-webhook-id: $webhookId",
            'x-wc-webhook-event: created',
            'x-wc-webhook-resource: checkout',
            'x-wc-webhook-source: ' . site_url(),
            'content-type: application/json',
        ];
    }

    public function sl_curl_execute($fields = [])
    {
        $this->response = '';

        $this->postfields = $fields;

        $this->sl_gocurl();
    }

    private function sl_gocurl()
    {
        $this->handle = curl_init();

        $curlopts = [
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_POST => 1,
            CURLOPT_URL => $this->url,
            CURLOPT_HTTPHEADER => $this->header,
            CURLOPT_POSTFIELDS => json_encode($this->postfields)
        ];

        curl_setopt_array($this->handle, $curlopts);

        $this->response = curl_exec($this->handle);

        curl_close($this->handle);

//        $log = fopen(SL_PATH . 'api_error.log', 'a');
//        $time = date('Y-m-d H:i:s');
//        $message = "[$time] url:{$this->url} header:" . print_r($this->header, true) . "\n";
//        $message .= 'post fields: ' . print_r($this->postfields, true) . "\n\n";
//        $message .= 'response: ' . print_r($this->response, true) . "\n\n";
//        fwrite($log, $message);
//        fclose($log);
    }
}
