<?php

/**
 *
 * Abandoned cart integration with Sendlane API
 *
 * Plugin Name:       WooCommerce Abandon Cart for Sendlane
 * Plugin URI:        https://sendlane.com
 * Description:       Abandon cart plugin to feed abandoned cart emails to your Sendlane account
 * Version:           2.0
 * Author:            Sendlane
 * Author URI:        https://sendlane.com
 * License:           GNU General Public License v3.0
 * License URI:       http://www.gnu.org/licenses/gpl-3.0.html
 * Text Domain:       sendlane
 * Domain Path:       sendlane/languages
 *
 * @author      Go Web Smarty
 * @category    Plugin
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License v3.0
 *
 */

//exit on direct access
if (!defined('WPINC')) {
    die();
}

/**
 * Definitions
 */

define('SL_VERSION', '2.0');
define('SL_BASENAME', plugin_basename(__FILE__));
define('SL_NAME', 'Sendlane Woocommerce');
define('SL_PATH', plugin_dir_path(__FILE__));
define('SL_URL', plugin_dir_url(__FILE__));
define('SL_TABLE', 'sl_abandon_captured');
define('SL_SLUG', 'sendlane');
define('SL_TX', 'sendlane'); //textdomain
define('SL_WEBHOOK_TOPIC', 'action.woocommerce_add_to_cart');
define('WC_WEBHOOKS', 'wc_webhooks');

/**
 * Plugin Activator
 */

function sl_activate()
{
    require_once SL_PATH . 'inc/sl-activator.php';
    SL_Activator::activate();
}

function sl_deactivate()
{
    require_once SL_PATH . 'inc/sl-deactivator.php';
    SL_Deactivator::deactivate();
}

register_activation_hook(__FILE__, 'sl_activate');
register_deactivation_hook(__FILE__, 'sl_deactivate');

/**
 * SL CORE class
 * Handles the entire functionality of the plugin
 *
 */

require SL_PATH . 'inc/sl-core.php';

function sl_execute()
{
    $cmd = new SendLane();
    $cmd->run();
}

sl_execute();
